Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.smardec.asc.animatepanel
Class JAnimatePanel

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JPanel
                              |
                              +--com.smardec.asc.animatepanel.JAnimatePanel

All Implemented Interfaces:
  javax.accessibility.Accessible, java.lang.Cloneable, java.awt.image.ImageObserver, java.awt.MenuContainer, javax.swing.Scrollable, java.io.Serializable

public class JAnimatePanel
extends javax.swing.JPanel
implements java.lang.Cloneable, javax.swing.Scrollable

`JAnimatePanel` provides API to create animated panels. It has various settings and can be easily customized to fit any application's needs.

Field Summary
`static int` | `MODE_ANIMATE` The animate paint mode constraint.
`static int` | `MODE_DEFAULT` The default paint mode constraint.

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JAnimatePanel()` Constructs a `JAnimatePanel`.

Method Summary
`void` | `addTab(int index, JAnimateTab jAnimateTab)` Inserts the specified tab at the specified position in this `JAnimatePanel`.
`void` | `addTab(JAnimateTab jAnimateTab)` Appends the specified tab to the end of this `JAnimatePanel`.
`java.awt.Font` | `getAnimateTabHeaderFont()` Returns the font of tab's headers in this `JAnimatePanel`.
`AnimateTabHeaderRenderer` | `getAnimateTabHeaderRenderer()` Returns the renderer used to display the tab's headers in this `JAnimatePanel`.
`int` | `getDefaultPaintMode()` Returns the current default paint mode of this `JAnimatePanel`
`int` | `getDelay()` Returns the sleep time between steps during animation in this `JAnimatePanel`.
`int` | `getIndentBottom()` Returns the bottom indent of the tabs in this `JAnimatePanel`.
`int` | `getIndentLeft()` Returns the left indent of the tabs in this `JAnimatePanel`.
`int` | `getIndentRight()` Returns the right indent of the tabs in this `JAnimatePanel`.
`int` | `getIndentTop()` Returns the top indent of the tabs in this `JAnimatePanel`.
`AnimatePanelRenderer` | `getOutlookTabBodyRenderer()` Returns the renderer used to display this `JAnimatePanel`.
`int` | `getStep()` Returns step size during animation in this `JAnimatePanel`.
`JAnimateTab` | `getTab(int index)` Returns the tab at the specified position in this `JAnimatePanel`.
`int` | `getTabCount()` Returns the number of tabs in this `JAnimatePanel`.
`int` | `getTabHeight()` Returns the height of the tabs in this `JAnimatePanel`.
`int` | `getTabIndex(JAnimateTab jAnimateTab)` Returns the index of the specified tab, or -1 if this `JAnimatePanel` does not contain this tab.
`int` | `getTabSpacing()` Returns the space between tabs in this `JAnimatePanel`.
`int` | `getTabWidth()` Returns the width of the tabs in this `JAnimatePanel`.
`void` | `hideTab(int index)` Hides `JAnimateTab` using default paint mode.
`void` | `hideTab(int index, int paintMode)` Hides `JAnimateTab` using paint mode `paintMode`.
`boolean` | `isBlockEvents()` Indicates whether this `JAnimatePanel` should block mouse and keyboard events during animation.
`JAnimateTab` | `removeTab(int index)` Removes the tab at the specified position in this `JAnimatePanel`.
`boolean` | `removeTab(JAnimateTab jAnimateTab)` Removes the specified tab from this `JAnimatePanel`.
`void` | `setAnimatePanelRenderer(AnimatePanelRenderer animatePanelRenderer)` Specifies the renderer used to display this `JAnimatePanel`.
`void` | `setAnimateTabHeaderFont(java.awt.Font animateTabHeaderFont)` Specifies the font of tab's headers in this `JAnimatePanel`.
`void` | `setAnimateTabHeaderRenderer(AnimateTabHeaderRenderer tabHeaderRenderer)` Specifies the renderer used to display the tab's headers in this `JAnimatePanel`.
`void` | `setBlockEvents(boolean blockEvents)` Specifies whether this `JAnimatePanel` should block mouse and keyboard events during animation depending on the value of parameter `blockEvents`.
`void` | `setDefaultPaintMode(int paintMode)` Specifies the default paint mode of this `JAnimatePanel`.
`void` | `setDelay(int delay)` Specifies the sleep time between steps during animation in this `JAnimatePanel`.
`void` | `setIndentBottom(int indentBottom)` Specifies the bottom indent of tabs in this `JAnimatePanel`.
`void` | `setIndentLeft(int indentLeft)` Specifies the left indent of tabs in this `JAnimatePanel`.
`void` | `setIndentRight(int indentRight)` Specifies the right indent of tabs in this `JAnimatePanel`.
`void` | `setIndentTop(int indentTop)` Specifies the top indent of tabs in this `JAnimatePanel`.
`void` | `setStep(int step)` Specifies step size during animation in this `JAnimatePanel`.
`void` | `setTabHeight(int tabHeight)` Specifies the height of the tabs in this `JAnimatePanel`.
`void` | `setTabSpacing(int tabSpacing)` Specifies the space between tabs in this `JAnimatePanel`.
`void` | `showTab(int index)` Shows `JAnimateTab` using default show mode.
`void` | `showTab(int index, int paintMode)` Shows `JAnimateTab` using show mode `paintMode`.

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.swing.Scrollable
`getPreferredScrollableViewportSize, getScrollableBlockIncrement, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getScrollableUnitIncrement`

Field Detail

### MODE_DEFAULT

    public static final int MODE_DEFAULT

  The default paint mode constraint.

  See Also:
    Constant Field Values

### MODE_ANIMATE

    public static final int MODE_ANIMATE

  The animate paint mode constraint. `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  See Also:
    Constant Field Values

Constructor Detail

### JAnimatePanel

    public JAnimatePanel()

  Constructs a `JAnimatePanel`.

Method Detail

### getTabCount

    public int getTabCount()

  Returns the number of tabs in this `JAnimatePanel`.

  Returns:
    the number of tabs in this `JAnimatePanel`.

### getTab

    public JAnimateTab getTab(int index)

  Returns the tab at the specified position in this `JAnimatePanel`.

  Parameters:
    `index` - index of tab to return
  Returns:
    the tab at the specified position in this `JAnimatePanel`.
  Throws:
    `java.lang.IllegalArgumentException` - index is out of range (index < 0 || index >= `getTabCount()`).

### getTabIndex

    public int getTabIndex(JAnimateTab jAnimateTab)

  Returns the index of the specified tab, or -1 if this `JAnimatePanel` does not contain this tab.

  Parameters:
    `jAnimateTab` - an `JAnimateTab`
  Returns:
    the index of the specified tab in this `JAnimatePanel`.

### getTabSpacing

    public int getTabSpacing()

  Returns the space between tabs in this `JAnimatePanel`.

  Returns:
    the space in pixels between tabs in this `JAnimatePanel`.
  See Also:
    `setTabSpacing(int)`

### setTabSpacing

    public void setTabSpacing(int tabSpacing)

  Specifies the space between tabs in this `JAnimatePanel`.

  Parameters:
    `tabSpacing` - the new space in pixels between tabs in this `JAnimatePanel`
  See Also:
    `getTabSpacing()`

### getDelay

    public int getDelay()

  Returns the sleep time between steps during animation in this `JAnimatePanel`.

  Returns:
    sleep time in milliseconds.

### setDelay

    public void setDelay(int delay)

  Specifies the sleep time between steps during animation in this `JAnimatePanel`.

  Parameters:
    `delay` - sleep time in milliseconds.

### getStep

    public int getStep()

  Returns step size during animation in this `JAnimatePanel`.

  Returns:
    step size in pixels.

### setStep

    public void setStep(int step)

  Specifies step size during animation in this `JAnimatePanel`.

  Parameters:
    `step` - step size in pixels.

### getIndentLeft

    public int getIndentLeft()

  Returns the left indent of the tabs in this `JAnimatePanel`.

  Returns:
    the left indent of the tabs in this `JAnimatePanel`.

### setIndentLeft

    public void setIndentLeft(int indentLeft)

  Specifies the left indent of tabs in this `JAnimatePanel`.

  Parameters:
    `indentLeft` - the left indent of the tabs in this `JAnimatePanel`.

### getIndentRight

    public int getIndentRight()

  Returns the right indent of the tabs in this `JAnimatePanel`.

  Returns:
    the right indent of the tabs in this `JAnimatePanel`.

### setIndentRight

    public void setIndentRight(int indentRight)

  Specifies the right indent of tabs in this `JAnimatePanel`.

  Parameters:
    `indentRight` - the right indent of the tabs in this `JAnimatePanel`.

### getIndentTop

    public int getIndentTop()

  Returns the top indent of the tabs in this `JAnimatePanel`.

  Returns:
    the top indent of the tabs in this `JAnimatePanel`.

### setIndentTop

    public void setIndentTop(int indentTop)

  Specifies the top indent of tabs in this `JAnimatePanel`.

  Parameters:
    `indentTop` - top left indent of the tabs in this `JAnimatePanel`.

### getIndentBottom

    public int getIndentBottom()

  Returns the bottom indent of the tabs in this `JAnimatePanel`.

  Returns:
    the bottom indent of the tabs in this `JAnimatePanel`.

### setIndentBottom

    public void setIndentBottom(int indentBottom)

  Specifies the bottom indent of tabs in this `JAnimatePanel`.

  Parameters:
    `indentBottom` - the bottom indent of the tabs in this `JAnimatePanel`.

### getTabHeight

    public int getTabHeight()

  Returns the height of the tabs in this `JAnimatePanel`.

  Returns:
    the height in pixels of the tabs in this `JAnimatePanel`.
  See Also:
    `setTabHeight(int)`

### setTabHeight

    public void setTabHeight(int tabHeight)

  Specifies the height of the tabs in this `JAnimatePanel`.

  Parameters:
    `tabHeight` - the new height in pixels of the tabs in this `JAnimatePanel`
  See Also:
    `getTabHeight()`

### getTabWidth

    public int getTabWidth()

  Returns the width of the tabs in this `JAnimatePanel`. The width equals `jAnimatePanel.getWidth() - jAnimatePanel.getInsets().left - jAnimatePanel.getInsets().right - jAnimatePanel.getIndentLeft() - jAnimatePanel.getIndentRight()`

  Returns:
    the width in pixels of the tabs in this `JAnimatePanel`

### getAnimateTabHeaderRenderer

    public AnimateTabHeaderRenderer getAnimateTabHeaderRenderer()

  Returns the renderer used to display the tab's headers in this `JAnimatePanel`.

  Returns:
    the `AnimateTabHeaderRenderer` that displays the tab's headers
  See Also:
    `setAnimateTabHeaderRenderer(com.smardec.asc.animatepanel.AnimateTabHeaderRenderer)`

### setAnimateTabHeaderRenderer

    public void setAnimateTabHeaderRenderer(AnimateTabHeaderRenderer tabHeaderRenderer)

  Specifies the renderer used to display the tab's headers in this `JAnimatePanel`.

  Parameters:
    `tabHeaderRenderer` - a `AnimateTabHeaderRenderer` that displays the tab's headers
  See Also:
    `getAnimateTabHeaderRenderer()`

### getOutlookTabBodyRenderer

    public AnimatePanelRenderer getOutlookTabBodyRenderer()

  Returns the renderer used to display this `JAnimatePanel`.

  Returns:
    the `AnimatePanelRenderer` that displays this `JAnimatePanel`
  See Also:
    `setAnimatePanelRenderer(AnimatePanelRenderer)`

### setAnimatePanelRenderer

    public void setAnimatePanelRenderer(AnimatePanelRenderer animatePanelRenderer)

  Specifies the renderer used to display this `JAnimatePanel`.

  Parameters:
    `animatePanelRenderer` - a `AnimatePanelRenderer` that displays this `JAnimatePanel`
  See Also:
    `getOutlookTabBodyRenderer()`

### getAnimateTabHeaderFont

    public java.awt.Font getAnimateTabHeaderFont()

  Returns the font of tab's headers in this `JAnimatePanel`.

  Returns:
    the font of tab's headers in this `JAnimatePanel`
  See Also:
    `setAnimateTabHeaderFont(java.awt.Font)`

### setAnimateTabHeaderFont

    public void setAnimateTabHeaderFont(java.awt.Font animateTabHeaderFont)

  Specifies the font of tab's headers in this `JAnimatePanel`.

  Parameters:
    `animateTabHeaderFont` - a font of tab's headers in this `JAnimatePanel`
  See Also:
    `getAnimateTabHeaderFont()`

### addTab

    public void addTab(int index,
                       JAnimateTab jAnimateTab)

  Inserts the specified tab at the specified position in this `JAnimatePanel`. Shifts the tab currently at that position (if any) and any subsequent tabs to the bottom (adds one to their indices).

  Parameters:
    `index` - index at which the specified tab is to be inserted
    `jAnimateTab` - a tab to be inserted
  See Also:
    `removeTab(int)`

### addTab

    public void addTab(JAnimateTab jAnimateTab)

  Appends the specified tab to the end of this `JAnimatePanel`.

  Parameters:
    `jAnimateTab` - tab to be appended to this `JAnimatePanel`
  See Also:
    `removeTab(int)`

### removeTab

    public JAnimateTab removeTab(int index)

  Removes the tab at the specified position in this `JAnimatePanel`. Shifts any subsequent tabs to the top (subtracts one from their indices). Returns the tab that was removed from the `JAnimatePanel`.

  Parameters:
    `index` - the index of the tab to be removed
  Returns:
    the tab that was removed
  See Also:
    `removeTab(JAnimateTab)`, `addTab(int, com.smardec.asc.animatepanel.JAnimateTab)`, `addTab(com.smardec.asc.animatepanel.JAnimateTab)`

### removeTab

    public boolean removeTab(JAnimateTab jAnimateTab)

  Removes the specified tab from this `JAnimatePanel`. If the `JAnimatePanel` does not contain the tab, it is unchanged.

  Parameters:
    `jAnimateTab` - tab to be removed from this JAnimatePanel, if present
  Returns:
    `true` if the JAnimatePanel contained the specified tab.
  See Also:
    `removeTab(int)`, `addTab(int, JAnimateTab)`, `addTab(JAnimateTab)`

### getDefaultPaintMode

    public int getDefaultPaintMode()

  Returns the current default paint mode of this `JAnimatePanel`

  Returns:
    the current default paint mode of this `JAnimatePanel`
  See Also:
    `setDefaultPaintMode(int)`

### setDefaultPaintMode

    public void setDefaultPaintMode(int paintMode)

  Specifies the default paint mode of this `JAnimatePanel`. You must specify one of the following choices: `MODE_DEFAULT` or `MODE_ANIMATE`.
  Note: `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  Parameters:
    `paintMode` - the default paint mode of this `JAnimatePanel`

### isBlockEvents

    public boolean isBlockEvents()

  Indicates whether this `JAnimatePanel` should block mouse and keyboard events during animation. The default is `true`.

  Returns:
    `true` if this `JAnimatePanel` blocks mouse and keyboard events during animation, `false` otherwise
  See Also:
    `setBlockEvents(boolean)`

### setBlockEvents

    public void setBlockEvents(boolean blockEvents)

  Specifies whether this `JAnimatePanel` should block mouse and keyboard events during animation depending on the value of parameter `blockEvents`. The default is `true`.

  Parameters:
    `blockEvents` - if `true` this `JAnimatePanel` blocks mouse and keyboard events during animation, `false` otherwise
  See Also:
    `isBlockEvents()`

### showTab

    public void showTab(int index)

  Shows `JAnimateTab` using default show mode.
  Note: `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  Parameters:
    `index` - index of tab than will be shown
  See Also:
    `setDefaultPaintMode(int)`

### showTab

    public void showTab(int index,
                        int paintMode)

  Shows `JAnimateTab` using show mode `paintMode`. You must specify one of the following modes: `MODE_DEFAULT` or `MODE_ANIMATE`.
  Note: `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  Parameters:
    `index` - index of tab that will be shown
    `paintMode` - indicates how the specified tab will be shown

### hideTab

    public void hideTab(int index)

  Hides `JAnimateTab` using default paint mode.
  Note: `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  Parameters:
    `index` - index of tab that will be hidden
  See Also:
    `setDefaultPaintMode(int)`

### hideTab

    public void hideTab(int index,
                        int paintMode)

  Hides `JAnimateTab` using paint mode `paintMode`. You must specify one of the following modes: `MODE_DEFAULT` or `MODE_ANIMATE`.
  Note: `MODE_ANIMATE` is available only if there is enough space to show all selected panels depending on their preferred sizes.

  Parameters:
    `index` - index of tab that will be hidden
    `paintMode` - paintMode indicates how the specified tab will be hidden

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2006 Smardec. All Rights Reserved.